From 4b07ab92e3fc900a4d712691533e6b77188e9785 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 23 2020 02:50:21 +0000
Subject: [PATCH 342/2232] Improve span of unsized opaque type error


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 36f25c5..8b3602a 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -32,7 +32,8 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
                 has_rust_type = true;
             }
             let ident = &ety.ident;
-            hidden.extend(quote!(__assert_sized::<#ident>();));
+            let span = ident.span();
+            hidden.extend(quote_spanned!(span=> __assert_sized::<#ident>();));
         }
     }
 
diff --git a/tests/ui/opaque_not_sized.stderr b/tests/ui/opaque_not_sized.stderr
index 1146b80..e93a546 100644
--- a/tests/ui/opaque_not_sized.stderr
+++ b/tests/ui/opaque_not_sized.stderr
@@ -1,13 +1,12 @@
 error[E0277]: the size for values of type `str` cannot be known at compilation time
- --> $DIR/opaque_not_sized.rs:1:1
+ --> $DIR/opaque_not_sized.rs:4:14
   |
 1 | #[cxx::bridge]
-  | ^^^^^^^^^^^^^^
-  | |
-  | doesn't have a size known at compile-time
-  | required by this bound in `ffi::_::__assert_sized`
+  | -------------- required by this bound in `ffi::_::__assert_sized`
+...
+4 |         type TypeR;
+  |              ^^^^^ doesn't have a size known at compile-time
   |
   = help: within `TypeR`, the trait `std::marker::Sized` is not implemented for `str`
   = note: to learn more, visit <https://doc.rust-lang.org/book/ch19-04-advanced-types.html#dynamically-sized-types-and-the-sized-trait>
   = note: required because it appears within the type `TypeR`
-  = note: this error originates in an attribute macro (in Nightly builds, run with -Z macro-backtrace for more info)

